VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cSquares"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"cSquare"
Attribute VB_Ext_KEY = "Member0" ,"cSquare"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Private Local_oCollection As Collection         ' Local copy of the collection object
Private Local_oItemStart As cSquare             ' Local copy of start square
Private Local_oItemDestination As cSquare       ' Local copy of destination square

' Property Access to Start and Destination square
Public Property Get ItemStart() As cSquare
    Set ItemStart = Local_oItemStart
End Property
Public Property Set ItemStart(oItem As cSquare)
    Set Local_oItemStart = oItem
End Property
Public Property Get ItemDestination() As cSquare
    Set ItemDestination = Local_oItemDestination
End Property
Public Property Set ItemDestination(oItem As cSquare)
    Set Local_oItemDestination = oItem
End Property

' Add an object to the collection
Public Function Add(nAltitude As Byte) As cSquare

    Dim oNew As cSquare     ' Variable to hold new member
    
    ' Create new member
    Set oNew = New cSquare

    ' Set propertys of member
    oNew.X = (Local_oCollection.Count) Mod 40
    oNew.Y = (Local_oCollection.Count) \ 40
    oNew.Altitude = nAltitude
    Set oNew.Parent = Me
    
    ' Add member
    Local_oCollection.Add oNew

    ' Return created member
    Set Add = oNew
    
    ' Clean up local copy of new object
    Set oNew = Nothing


End Function

' Access to item in collection
Public Property Get Item(nIndex As Integer) As cSquare
Attribute Item.VB_UserMemId = 0
  Set Item = Local_oCollection(nIndex + 1)
End Property

' Return member count
Public Property Get Count() As Long
    Count = Local_oCollection.Count
End Property

' Remove a member from the collection
Public Sub Remove(nIndex As Integer)
    Local_oCollection.Remove nIndex + 1
End Sub

' Clear all members from the collection
Public Sub Clear()
    Do While Local_oCollection.Count > 0
        Local_oCollection.Remove (Local_oCollection.Count)
    Loop
End Sub

' Redraw all members
Public Sub Redraw()

    Dim oSquare As cSquare
    For Each oSquare In Local_oCollection
        oSquare.Redraw
    Next
    
End Sub
' Class initalization: Create collection object locally
Private Sub Class_Initialize()
    Set Local_oCollection = New Collection
End Sub

' Class termination: Release local collection object
Private Sub Class_Terminate()
    Set Local_oCollection = Nothing
End Sub

